unit CosaEditorUnit;

{$mode delphi}

interface

uses
  Classes, SysUtils, uFormularioAutomatico,
  StdCtrls, maskedit, EditBtn, Grids, ExtCtrls, Dialogs;

type

  { TFichaLPDForm }

  TFichaLPDForm=class(TFormularioAutomatico)
    procedure EsPeriodicaCheckBoxOnChange(Sender: TObject);
  public
    EsPeriodicaCheckBox:TCheckBox;
    PeriodicidadButton:TButton;

    procedure SetControls(); override;
    procedure SetEventHandlers(); override;
    procedure RunEventHandlers(); override;
  end;

  { TFichaGTer_BasicoForm }

  TFichaGTer_BasicoForm=class(TFichaLPDForm)
    procedure IndicePreciosPorCombustibleOnChange(Sender: TObject);
  public
    IndicePreciosPorCombustible:TComboBox;
    BornePreciosPorCombustible:TComboBox;

    procedure SetControls(); override;
    procedure SetEventHandlers(); override;
    procedure RunEventHandlers(); override;
  end;

implementation

uses
  ucosa;

{ TFichaGTer_BasicoForm }

procedure TFichaGTer_BasicoForm.IndicePreciosPorCombustibleOnChange(Sender: TObject
  );
var
  SelectedItem: String;
  ctrlParentBPPC:TDAOfStringTComboBoxControl;
  j: Integer;
  xlist:string;
  DataCell: TDataCellOfCosa;
  sval:string;
  split: TStringList;
  q: Integer;
  i: Integer;
  a:string;
  b:integer;
  DataVRow: TDataVRowOfCosa;
  dr:TDataRowOfCosa;
  ADataSet: TDataStore;
begin
  if (self.IndicePreciosPorCombustible.ItemIndex > 0) then
  begin
    SelectedItem:=self.IndicePreciosPorCombustible.Items[IndicePreciosPorCombustible.ItemIndex];

    DataVRow:=TDataVRowOfCosa(TDataCellOfCosa(self.IndicePreciosPorCombustible.Items.Objects[self.IndicePreciosPorCombustible.ItemIndex]).DataRowOwner);

    a:=DataVRow.OriginalDataTableName;

    ADataSet:=TDataStore.Create(nil);

    self.DataSet.Query('NombresDeBornes_Publicados', DataVRow.OriginalDataTableName, DataVRow.OriginalDataRowId, ADataSet);

    sval:=ADataSet.DataTableList[0].DataRowList[0].DataCellList[0].sval;
    split:=TStringList.Create;
    ExtractStrings(['[', '|', ',', ']',' '], [], PChar(sval), split);

    ctrlParentBPPC:=TDAOfStringTComboBoxControl(self.BornePreciosPorCombustible.Parent);

    self.BornePreciosPorCombustible.Clear;
    for q:=1 to split.Count-1 do
    begin
      self.BornePreciosPorCombustible.Items.Add(split[q]);
      if split[q]=ctrlParentBPPC.DataCell.sval then
        self.BornePreciosPorCombustible.ItemIndex:=q-1;
    end;
  end;
end;

procedure TFichaGTer_BasicoForm.SetControls;
var
  ok: Boolean;
  i: Integer;
  oldBPPCControl: TDAOfStringTComboBoxControl;
  newBPPCControl: TDAOfStringTComboBoxControl;
begin

  inherited;

  ok:=false;

  //1: OBTENGO LOS CONTROLES
  i:=self.GetIndexOfControl('IndicePreciosPorCombustible');
  if (i>-1) then
  begin
    self.IndicePreciosPorCombustible:=TEditorTComboBoxControl(self.ControlList.Items[i]).AComboBox;
    i:=self.GetIndexOfControl('BornePreciosPorCombustible');
    if (i>-1) then
    begin

      oldBPPCControl:=TDAOfStringTComboBoxControl(self.ControlList.Items[i]);

      {
       EL NIL ESE PUEDE ESTAR MAL
      }

      newBPPCControl:= TDAOfStringTComboBoxControl.Create(nil, oldBPPCControl.Parent, oldBPPCControl.DataColumn, oldBPPCControl.DataCell);
      self.ControlList.Delete(i);
      self.ControlList.Insert(i, newBPPCControl);
      oldBPPCControl.Free();

      self.BornePreciosPorCombustible:=TDAOfStringTComboBoxControl(self.ControlList.Items[i]).AComboBox;
      ok:=true;
    end;
  end;
end;

procedure TFichaGTer_BasicoForm.SetEventHandlers;
begin
  inherited;
  self.IndicePreciosPorCombustible.OnChange:=self.IndicePreciosPorCombustibleOnChange;
end;

procedure TFichaGTer_BasicoForm.RunEventHandlers;
begin
  inherited;
  self.IndicePreciosPorCombustibleOnChange(nil);
end;

{ TFichaLPDForm }

procedure TFichaLPDForm.EsPeriodicaCheckBoxOnChange(Sender: TObject);
begin
  if (self.EsPeriodicaCheckBox.Checked) then
    self.PeriodicidadButton.Enabled:=true
  else
    self.PeriodicidadButton.Enabled:=false;
end;

procedure TFichaLPDForm.SetControls;
var
  ok:boolean;
  i1,i2:integer;
begin

  inherited;

  ok:=false;

  //1: OBTENGO LOS CONTROLES
  i1:=self.GetIndexOfControl('esPeriodica');
  if (i1>-1) then
  begin
    self.EsPeriodicaCheckBox:=TEditorTCheckBoxControl(self.ControlList.Items[i1]).ACheckBox;
    i2:=self.GetIndexOfControl('periodicidad');
    if (i2>-1) then
    begin
      self.PeriodicidadButton:=TEditorTButtonControl(self.ControlList.Items[i2]).AButton;
      ok:=true;
    end;
  end;
end;

procedure TFichaLPDForm.SetEventHandlers();
begin
  //inherited SetEventHandlers();
  self.EsPeriodicaCheckBox.OnChange:=EsPeriodicaCheckBoxOnChange;
end;

procedure TFichaLPDForm.RunEventHandlers();
begin
  //inherited RunEventHandlers();
  self.EsPeriodicaCheckBoxOnChange(nil);
end;

end.

