unit uFormularioBase;

{$mode delphi}
{$DEFINE DEBUG}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, StdCtrls, EditBtn,
  xmatdefs, ucosa, maskedit, contnrs, ufechas;

type

  { TFormularioBase }

  TFormularioBase = class(TForm)
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);

  protected
    ParentForm: TFormularioBase;
    OnEnterVal: string;
    guardado: boolean;

  public
    { public declarations }

    SIUD:TSIUD;

    DataSet: TDataStore;
    hayCambios: boolean;

    constructor Create (TheOwner: TComponent); override; overload;
    constructor Create (TheOwner: TComponent; ADataSet: TDataStore; xTitle:string );

    procedure SaveToDataStore();

    //function PrepareInsert(Into, ColumnName: string; RowId: integer;
    //  Value: string; isItemOfList: boolean = True): TDataStore;
    //function PrepareUpdate(From, ColumnName: string; RowId: integer;
    //  Value: string; lst: boolean): TDataStore;
    //
    ////El delete solo se perimite para items de listas.
    //function PrepareDelete(From, ColumnName: string; RowId: integer;
    //  Value: string; lst: boolean = True): TDataStore;

    //function Query(Select: string; From: string; var DataSet: TDataStore): boolean;
    //  overload;
    //function Query(Select: string; From: string; ColumnName: string;
    //  ColumnValue: string; var DataSet: TDataStore): boolean; overload;
    //function Query(Select: string; From: string; RowId: integer;
    //  var DataSet: TDataStore): boolean;

    function Save(): integer; virtual; abstract;

    function HuboCambios(): boolean;

  end;

  FormBaseClass = class of TFormularioBase;


var
  FormularioBase: TFormularioBase;


implementation

{$R *.lfm}

uses
  uBaseFormularios, uBaseEditores, uBaseEditoresFichas, uBaseEditoresCosasConNombre;

{ TFormularioBase }

//constructor TFormularioBase.Create(AOwner: Tcomponent;
//  xParentForm: TFormularioBase; xTitle: string);
//begin
//  inherited Create(AOwner);
//  self.ParentForm := xParentForm;
//  self.Caption := xTitle;
//  self.hayCambios := False;
//end;

procedure TFormularioBase.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);

begin
//  if self.ModalResult = mrOK then
//    if assigned(self.DataSet) then
//      self.SaveToDataStore()
//else
//raise Exception.Create('TFormularioBase.FormClose: El DataSet de la ventana no peude ser nulo.');
end;

procedure TFormularioBase.SaveToDataStore;
var
  ADataSet:TDataStore;
  RowId: Integer;
  DataRow: TDataRowOfCosa;
  b: String;
begin
  ADataSet:=TDataStore.Create(self.DataSet);
  ADataSet:=self.DataSet.Clone(false,false);

  if ucosa.IsChild(TBaseFormularios, self.ClassType) then
  begin
    if ucosa.IsChild(TBaseEditores, self.ClassType) then
    begin
      if ucosa.IsChild(TBaseEditoresFichas, self.ClassType) then
      begin
        RowId:=ADataSet.CreateDataRowFromInstance(
          TBaseEditoresFichas(self).ficha,
          'dt_'+TBaseEditoresFichas(self).ficha.ClassName, '', true);
        DataRow:=ADataSet.GetDataTableByName('dt_'+TBaseEditoresFichas(self).ficha.ClassName).GetDataRowById(RowId);
      end
      else if ucosa.IsChild(TBaseEditoresCosasConNombre, self.ClassType) then
      begin
        RowId:=ADataSet.CreateDataRowFromInstance(
          TBaseEditoresCosasConNombre(self).cosaEditable,
          'dt_'+TBaseEditoresCosasConNombre(self).cosaEditable.ClassName, '', true);
        DataRow:=ADataSet.GetDataTableByName('dt_'+TBaseEditoresCosasConNombre(self).cosaEditable.ClassName).GetDataRowById(RowId);
        DataRow._RowId:=self.DataSet.DataTableList[0].DataRowList[0]._RowId;
        DataRow.SIUD:=TUPDATE;
      end;
    end;
  end;

  if assigned(ADataSet.GetDataTableByName('dt_TFuenteConstante')) then
  begin

    siud:=ADataSet.GetDataTableByName('dt_TFuenteConstante').DataRowList[0].SIUD;

    b:=ADataSet.GetDataTableByName('dt_TFuenteConstante').DataRowList[0].DataCellList[
      ADataSet.GetDataTableByName('dt_TFuenteConstante').GetIndexOfDataColumnByName('nombresdebornes_publicados')
    ].sval;
  end;

  self.DataSet.Merge(ADataSet);

  if assigned(self.DataSet.GetDataTableByName('dt_TFuenteConstante')) then
    b:=self.DataSet.GetDataTableByName('dt_TFuenteConstante').DataRowList[0].DataCellList[
      self.DataSet.GetDataTableByName('dt_TFuenteConstante').GetIndexOfDataColumnByName('nombresdebornes_publicados')
    ].sval;

  DataRow.SIUD:=self.SIUD;
  self.DataSet.DataSetParent.Merge(self.DataSet);

  if assigned(self.DataSet.DataSetParent.GetDataTableByName('dt_TFuenteConstante')) then
    b:=self.DataSet.DataSetParent.GetDataTableByName('dt_TFuenteConstante').DataRowList[0].DataCellList[
      self.DataSet.DataSetParent.GetDataTableByName('dt_TFuenteConstante').GetIndexOfDataColumnByName('nombresdebornes_publicados')
    ].sval;

end;

constructor TFormularioBase.Create(TheOwner: TComponent);
begin
  inherited Create(TheOwner);
//  self.dataSet:=TDataStore.Create();
end;

constructor TFormularioBase.Create(TheOwner: TComponent; ADataSet: TDataStore;
  xTitle: string);
begin
  self.Create(TheOwner);
  self.dataSet:=ADataSet;
  self.Caption:=xTitle;
end;


function TFormularioBase.HuboCambios: boolean;
begin

end;

//function TFormularioBase.PrepareInsert(Into, ColumnName: string;
//  RowId: integer; Value: string; isItemOfList: boolean): TDataStore;
//var
//  ds: TDataStore;
//  dr1, dr2: TDataRowOfCosa;
//  dt: TDataTableOfCosa;
//  dt_TList: TDataTableOfListOfCosa;
//
//  sval: string;
//  IdParent: string;
//  split: TStringList;
//  n: integer;
//  nsval: string;
//
//begin
//  ds := TDataStore.Create();
//  Query('*', Into, RowId, ds);
//  dt := ds.DataTableList[0];
//  dt.Visible := False;
//  Query('*', Value, 'AAA', '999', ds);
//  ds.DataTableList[1].Visible := True;
//  dr1 := ds.DataTableList[1].GetDataRowWithDefaulValues();
//  dr1.SIUD := TSIUD.TINSERT;
//  ds.DataTableList[1].AddDataRow(dr1);
//  if isItemOfList then
//  begin
//    ds.ReadDataCellTextValue(Into, RowId, 'n', nsval);
//    n := StrToInt(nsval);
//    ds.WriteDataCellTextValue(Into, RowId, 'n', IntToStr(n + 1));
//
//    Query('*', 'dt_TList', 'AAA', '999', ds);
//    dt_TList := TDataTableOfListOfCosa(ds.DataTableList[2]);
//    dt_TList.Visible := False;
//    dr2 := TDataRowOfCosa.Create;
//    dt_TList.AddDataRow(dr2);
//    dr2.SIUD := TSIUD.TINSERT;
//
//    ds.ReadDataCellTextValue(Into, RowId, ColumnName, sval);
//    if sval = '' then
//    begin
//      IdParent := IntToStr(dt_TList.GetNextIdParent());
//      ds.WriteDataCellTextValue(Into, RowId, ColumnName,
//        dt_TList.TableName + '.IdParent.' + IdParent);
//    end
//    else
//    begin
//      split := TStringList.Create;
//      try
//        ExtractStrings(['.'], [], PChar(sval), split);
//        IdParent := split[2];
//      finally
//        split.Free;
//      end;
//    end;
//
//    dr2.AddDataCell(TDataCellOfCosa.Create(IdParent));
//    dr2.AddDataCell(TDataCellOfCosa.Create(Value + '.' + IntToStr(dr1._RowId)));
//
//  end
//  else
//  begin
//    ds.WriteDataCellTextValue(Into, RowId, ColumnName, Value + '.' + IntToStr(dr1._RowId));
//  end;
//  Result := ds;
//end;
//
//function TFormularioBase.PrepareUpdate(From, ColumnName: string;
//  RowId: integer; Value: string; lst: boolean): TDataStore;
//var
//  ds: TDataStore;
//  dr1, dr2: TDataRowOfCosa;
//  dt: TDataTableOfCosa;
//
//  sval: string;
//  split: TStringList;
//  DataTableChildName: string;
//  DataRowChildId: integer;
//  lst_sval: string;
//  DataTableListName: string;
//  DataColumnName: string;
//  IdParent: string;
//  aDataTableItemName: string;
//  aDataRowItemId: integer;
//  j: integer;
//  ADataRow: TDataRowOfCosa;
//  ADataCell: TDataCellOfCosa;
//
//begin
//  ds := TDataStore.Create();
//  split := TStringList.Create;
//  try
//    ExtractStrings(['.'], [], PChar(Value), split);
//    DataTableChildName := split[0];
//    DataRowChildId := StrToInt(split[1]);
//  finally
//    split.Free;
//  end;
//
//  Query('*', DataTableChildName, DataRowChildId, ds);
//  ds.DataTableList[0].Visible := True;
//  if lst then
//  begin
//    //Como es una lista busco los items
//    ds.ReadDataCellTextValue(DataTableChildName, DataRowChildId, 'lst', lst_sval);
//
//    if (lst_sval <> '') then
//    begin
//      split := TStringList.Create;
//      try
//        ExtractStrings(['.'], [], PChar(lst_sval), split);
//        DataTableListName := split[0];
//        DataColumnName := split[1];
//        IdParent := split[2];
//      finally
//        split.Free;
//      end;
//      Query('*', DataTableListName, DataColumnName, IdParent, ds);
//      dt := ds.DataTableList[1];
//
//      for j := 0 to dt.DataRowListCount - 1 do
//      begin
//        ADataRow := dt.DataRowList[j];
//        if ADataRow.SIUD <> TSIUD.TDELETE then
//        begin
//          ADataCell := aDataRow.DataCellList[1];
//          split := TStringList.Create;
//          try
//            ExtractStrings(['.'], [], PChar(aDataCell.sval), split);
//            aDataTableItemName := split[0];
//            aDataRowItemId := StrToInt(split[1]);
//          finally
//            split.Free;
//          end;
//          Query('*', aDataTableItemName, aDataRowItemId, ds);
//          ds.GetDataTableByName(aDataTableItemName).Visible := False;
//        end;
//      end;
//    end;
//  end;
//
//  ds.DataTableList[0].DataRowList[0].SIUD := TSIUD.TUPDATE;
//
//  Result := ds;
//end;
//
//function TFormularioBase.PrepareDelete(From, ColumnName: string;
//  RowId: integer; Value: string; lst: boolean): TDataStore;
//var
//  ds, dsAux: TDataStore;
//  dtChildName: string;
//  drChildId: integer;
//
//  n: integer;
//  split: TStringList;
//
//  lst_sval: string;
//  IdParent: string;
//  nsval: string;
//
//begin
//  ds := TDataStore.Create();
//  Query('*', From, RowId, ds);
//  split := TStringList.Create;
//  try
//    ExtractStrings(['.'], [], PChar(Value), split);
//    dtChildName := split[0];
//    drChildId := StrToInt(split[1]);
//  finally
//    split.Free;
//  end;
//
//  Query('*', dtChildName, drChildId, ds);
//  ds.DataTableList[1].DataRowList[0].SIUD := TSIUD.TDELETE;
//  if lst then
//  begin
//    ds.ReadDataCellTextValue(From, RowId, 'n', nsval);
//    n := StrToInt(nsval);
//    ds.WriteDataCellTextValue(From, RowId, 'n', IntToStr(n - 1));
//
//    ds.ReadDataCellTextValue(From, RowId, 'lst', lst_sval);
//    split := TStringList.Create;
//    try
//      ExtractStrings(['.'], [], PChar(lst_sval), split);
//      IdParent := (split[2]);
//    finally
//      split.Free;
//    end;
//
//    dsAux := TDataStore.Create();
//    Query('*', 'dt_TList', 'IdParent', IdParent, ds);
//    ds.DeleteDataRows('dt_TList', 'IdChild', Value);
//
//
//    dsAux.Free;
//  end;
//
//  Result := ds;
//end;

//function TFormularioBase.Query(Select: string; From: string;
//  var DataSet: TDataStore): boolean;
//begin
//  Result := self.Query(Select, From, '', '', DataSet);
//end;
//
//function TFormularioBase.Query(Select: string; From: string;
//  ColumnName: string; ColumnValue: string; var DataSet: TDataStore): boolean;
//begin
//
//  if (self.DataSet.Query(Select, From, ColumnName, ColumnValue, DataSet) = False) then
//  begin
//    if (self.ParentForm <> nil) then
//      Result := self.ParentForm.Query(Select, From, ColumnName, ColumnValue, DataSet)
//    else
//      Result := DATA_STORE.Query(Select, From, ColumnName, ColumnValue, DataSet);
//  end
//  else
//    Result := True;
//end;
//
//function TFormularioBase.Query(Select: string; From: string;
//  RowId: integer; var DataSet: TDataStore): boolean;
//begin
//
//  if (self.DataSet.Query(Select, From, RowId, DataSet) = False) then
//  begin
//    if (self.ParentForm <> nil) then
//      Result := self.ParentForm.Query(Select, From, RowId, DataSet)
//    else
//      Result := DATA_STORE.Query(Select, From, RowId, DataSet);
//  end
//  else
//    Result := True;
//end;




end.
