unit uPrintCronVars;
{$MODE Delphi}


{$IFNDEF WINDOWS}
// ATENCION ESTO ES HASTA QUE ENCUENTRE LA MANERA
// DE GENERAR ALGO EN LINUX
{$DEFINE SIMRES3SOLOTEXTO}
{$ENDIF}

interface
uses
{$IFNDEF SIMRES3SOLOTEXTO}
  Graphics,
  uExcelFile, Dialogs,
 {$ENDIF}
  uHistoVarsOps, uPrint, xMatDefs, uAuxiliares, SysUtils,
  uversiones,
  uConstantesSimSEE,
  Classes;


{$IFDEF SIMRES3SOLOTEXTO}
type
  TExcelFile = pointer; // solo para que compile
{$ENDIF}



type
  TClaseDePrintCronVar = class of TPrintCronVar;
  TPrintCronVar = class
  public
    nombreHoja: string;
    titulo, unidades: string;
    digitos, decimales: integer;

    //Retorna false si los parametros no son correctos. En caso de error
    //se agrega una línea por error en errores con la descripcion del problema
    //encontrado
    //Se llama antes de llamar a imprimirse y luego de haber calculado las
    //cronOpers y postOpers
    procedure checkParams(errores: TStringList); virtual;

    // Retonra TRUE si necesita Excel
    function usa_excel: boolean; virtual;

    procedure imprimirse(xls: TExcelFile); virtual; abstract;
{$IFNDEF SIMRES3SOLOTEXTO}
    procedure imprimirseYCopiarAWord(xls: TExcelFile;
      wordApp: variant); virtual; abstract;
{$ENDIF}
    class function tipo: string; virtual; abstract;

    function getNombresCronVars: string; virtual; abstract;
    function referenciaCronVar(cronVar: TCronVar): boolean; virtual; abstract;
    function parametrosAdicionales: string; virtual;
{$IFNDEF SIMRES3SOLOTEXTO}
    //Retorna la lista de colores que se hayan seleccionado especificamente para
    //su grafico
    function getColores: TDAOfTColor; virtual;
{$ENDIF}
    function serialize: string; virtual;

    function cronVarsAImprimir: TDAOfCronVar; virtual; abstract;
  end;

  TPrintCronVar_UniCronVar = class(TPrintCronVar)
  public
    cronVar: TCronVar;
    function getNombresCronVars: string; override;
    function referenciaCronVar(cronVar: TCronVar): boolean; override;
    function serialize: string; override;

    function cronVarsAImprimir: TDAOfCronVar; override;
  end;

  TPrintCronVar_MultiCronVar = class(TPrintCronVar)
  public
    cronVars: TDAOfCronVar;
    function getNombresCronVars: string; override;
    function referenciaCronVar(cronVar: TCronVar): boolean; override;
    procedure Free;
    //      function serialize: string; override;

    function cronVarsAImprimir: TDAOfCronVar; override;
  end;

{$IFNDEF SIMRES3SOLOTEXTO}
  TPrintCronVar_matrizDeDatos = class(TPrintCronVar_UniCronVar)
  private
    //Si no se definieron títulos para todas las columnas agrega las columnas
    //que faltan con título CrónicaN con N el número de columna
    function titulosColsExt: TDAofString;
  public
    Print_promedio: boolean;
    titulosCols: TDAofString;
    chart_Mat: boolean;
    minEjeYAuto, maxEjeYAuto: boolean;
    minEjeY, MaxEjeY: NReal;

    constructor Create(cronVar: TCronVar; nombreHoja: string;
      titulo, unidades: string;
      titulosCols: TDAofString;
      digitos, decimales: integer;
      Print_promedio: boolean;
      chart_Mat: boolean;
      minEjeYAuto, maxEjeYAuto: boolean;
      minEjeY, MaxEjeY: NReal);

    procedure imprimirse(xls: TExcelFile); override;
    class function tipo: string; override;
    procedure Free;
    function parametrosAdicionales: string; override;
    function serialize: string; override;

  end;


  TPrintCronVar_histograma = class(TPrintCronVar_UniCronVar)
  public
    chart_Mat: boolean;
    minEjeYAuto, maxEjeYAuto: boolean;
    minEjeY, MaxEjeY: NReal;
    Print_Todas: boolean;
    Print_promedio: boolean;
    Pre_Ordenar: boolean;
    Print_probAisladas: TDAofNReal;
    TipoImpresion_PE: boolean;

    constructor Create(cronVar: TCronVar; nombreHoja: string;
      titulo, unidades: string;
      digitos, decimales: integer;
      Print_Todas: boolean;
      Print_promedio: boolean;
      Pre_Ordenar: boolean;
      TipoImpresion_PE: boolean;
      Print_probAisladas: TDAofNReal;
      chart_Mat: boolean;
      minEjeYAuto, maxEjeYAuto: boolean;
      minEjeY, MaxEjeY: NReal);
    procedure imprimirse(xls: TExcelFile); override;
(*
      procedure imprimirseYCopiarAWord(xls: TExcelFile;
                                       wordApp: Variant); override;
*)
    class function tipo: string; override;
    procedure Free;
    function parametrosAdicionales: string; override;
    class function printProbAisladasPorDefecto: TDAofNReal;
    function serialize: string; override;
  end;

{$ENDIF}


  TPrintCronVar_histograma_text = class(TPrintCronVar_UniCronVar)
  public
    Print_Todas: boolean;
    Print_promedio: boolean;
    Pre_Ordenar: boolean;
    TipoImpresion_PE: boolean;
    Print_probAisladas: TDAofNReal;
    constructor Create(cronVar: TCronVar; archi: string;
      titulo, unidades: string;
      digitos, decimales: integer;
      Print_Todas: boolean;
      Print_promedio: boolean;
      Pre_Ordenar: boolean;
      TipoImpresion_PE: boolean;
      Print_probAisladas: TDAofNReal);


    function usa_excel: boolean; override;
    procedure imprimirse(xls: TExcelFile); override;
    class function tipo: string; override;
    procedure Free;
    function parametrosAdicionales: string; override;
    class function printProbAisladasPorDefecto: TDAofNReal;
    function serialize: string; override;
  end;

{$IFNDEF SIMRES3SOLOTEXTO}
  TPrintCronVar_HistogramaGlobal = class(TPrintCronVar_UniCronVar)
  public
    minX, maxX: NReal;
    nPuntosHistograma: integer;

    constructor Create(cronVar: TCronVar; nombreHoja: string;
      titulo, unidades: string;
      digitos, decimales: integer;
      minX, maxX: NReal; nPuntosHistograma: integer{;
                         chart_Mat: boolean;
                         minEjeYAuto, maxEjeYAuto: boolean;
                         minEjeY, MaxEjeY: NReal});
    procedure imprimirse(xls: TExcelFile); override;
    procedure imprimirseYCopiarAWord(xls: TExcelFile;
      wordApp: variant); override;
    class function tipo: string; override;
    procedure Free;
    function serialize: string; override;
  end;

  TPrintCronVar_compararValoresMultiplesCronVars = class(TPrintCronVar_MultiCronVar)
  public
    tipoValorAComparar: TTipoValoresAComparar;
    //Solo aplica si el tipoValorAComparar = ProbabilidadesDeExcedencia
    probExcedencia: NReal;

    Pre_Ordenar: boolean;
    ProbExcedencia_Sup: NReal; // borde superior

    graficar: boolean;
    minEjeYAuto, maxEjeYAuto: boolean;
    minEjeY, MaxEjeY: NReal;

    tiposGraficos: TDAOfTTipoGrafico;
    ejes: TDAOfTTipoEje;
    //clDefault hace que elija automático
    colores: TDAOfTColor;

    constructor Create(cronVars: TDAOfCronVar;
      nombreHoja: string;
      titulo, unidades: string;
      digitos, decimales: integer;
      tipoValorAComparar: TTipoValoresAComparar;
      probExcedencia: NReal;

      Pre_Ordenar: boolean;
      ProbExcedencia_Sup: NReal;
      graficar: boolean;
      tiposGraficos: TDAOfTTipoGrafico;
      ejes: TDAOfTTipoEje;
    //clDefault hace que elija automático
      colores: TDAOfTColor;
      minEjeYAuto, maxEjeYAuto: boolean;
      minEjeY, MaxEjeY: NReal);

    procedure checkParams(errores: TStringList); override;
    procedure imprimirse(xls: TExcelFile); override;
    procedure imprimirseYCopiarAWord(xls: TExcelFile;
      wordApp: variant); override;
    class function tipo: string; override;
    procedure Free;
    function parametrosAdicionales: string; override;
    function getColores: TDAOfTColor; override;
    function serialize: string; override;
  end;

{$ENDIF}


  TPrintCronVar_R = class(TPrintCronVar_MultiCronVar)
  public
    carpeta_destino: string;
    R_archi: string;
    R_script: string;
    cronVars: TDAOfCronVar;
    constructor Create(cronVars: TDAOfCronVar;
      carpeta_destino: string; R_Archi: string;
      R_Script: string);

    procedure imprimirse(xls: TExcelFile); override;

    function usa_excel: boolean; override;
    class function tipo: string; override;
    procedure Free;
    function parametrosAdicionales: string; override;
    function serialize: string; override;
  end;


implementation
uses
  uAuxiliaresEscrituraSimRes;

//------------------------
//Métodos de TPrintCronVar
//========================

procedure TPrintCronVar.checkParams(errores: TStringList);
begin
  //Nada
end;


// Retonra TRUE si necesita Excel
function TPrintCronVar.usa_excel: boolean;
begin
  Result := True; // por defecto que lo sobreescriban las que precisen otra cosa
end;

function TPrintCronVar.parametrosAdicionales: String;
begin
  Result := '-';
end;

{$IFNDEF SIMRES3SOLOTEXTO}
function TPrintCronVar.getColores: TDAOfTColor;
begin
  Result := nil;
end;
{$ENDIF}

function TPrintCronVar.serialize: string;
begin
  Result := tipo;
end;

//----------------------------------
//Métodos de TPrintCronVarUniCronVar
//==================================

function TPrintCronVar_UniCronVar.getNombresCronVars: String;
begin
  Result := cronVar.nombre;
end;

function TPrintCronVar_UniCronVar.referenciaCronVar(cronVar: TCronVar): boolean;
begin
  Result := self.cronVar = cronVar;
end;

function TPrintCronVar_UniCronVar.serialize: String;
begin
  Result := inherited serialize + #9 + encomille(cronVar.nombre);
end;

function TPrintCronVar_UniCronVar.cronVarsAImprimir: TDAOfCronVar;
var
  res: TDAOfCronVar;
begin
  SetLength(res, 1);
  res[0] := cronVar;
  result := res;
end;

//------------------------------------
//Métodos de TPrintCronVarMultiCronVar
//====================================

function TPrintCronVar_MultiCronVar.getNombresCronVars: String;
var
  res: String;
  i: Integer;
begin
  if Length(cronVars) > 0 then
  begin
    res := cronVars[0].nombre;
    for i := 1 to high(cronVars) do
      res := res + ', ' + cronVars[i].nombre;
  end
  else
    res := '';
  Result := res;
end;

function TPrintCronVar_MultiCronVar.referenciaCronVar(cronVar: TCronVar): boolean;
var
  referencia: boolean;
  i: Integer;
begin
  referencia := False;
  for i := 0 to high(cronVars) do
    if cronVars[i] = cronVar then
    begin
      referencia := True;
      break;
    end;
  Result := referencia;
end;

procedure TPrintCronVar_MultiCronVar.Free;
begin
  SetLength(cronVars, 0);
  inherited Free;
end;

function TPrintCronVar_MultiCronVar.cronVarsAImprimir: TDAOfCronVar;
begin
  result := cronVars;
end;

//--------------------------------------
//Métodos de TPrintCronVar_matrizDeDatos
//======================================

{$IFNDEF SIMRES3SOLOTEXTO}
Constructor TPrintCronVar_matrizDeDatos.Create(cronVar: TCronVar;
  nombreHoja: string;
  titulo, unidades: string;
  titulosCols: TDAofString;
  digitos, decimales: integer;
  Print_promedio: boolean;
  chart_Mat: boolean;
  minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal);
begin
  inherited Create;
  self.cronVar := cronVar;
  self.nombreHoja := nombreHoja;
  self.titulo := titulo;
  self.unidades := unidades;
  self.titulosCols := titulosCols;
  self.digitos := digitos;
  self.decimales := decimales;
  self.Print_promedio := Print_promedio;
  self.chart_Mat := chart_Mat;
  self.minEjeYAuto := minEjeYAuto;
  self.maxEjeYAuto := maxEjeYAuto;
  self.minEjeY := minEjeY;
  self.MaxEjeY := MaxEjeY;
end;

procedure TPrintCronVar_matrizDeDatos.imprimirse(xls: TExcelFile);
begin
  WriteMatToXLS_SinOrdenar(
    xls, nombreHoja, cronVar.v_,
    titulo, unidades, titulosColsExt,
    cronVar.nPasos,
    cronVar.nCronicas,
    cronVar.dtIni,
    cronVar.DurPaso_horas / 24,
    decimales,
    Print_promedio, chart_Mat,
    minEjeYAuto, maxEjeYAuto, minEjeY, MaxEjeY);
end;

(*
procedure TPrintCronVar_matrizDeDatos.imprimirseYCopiarAWord(xls: TExcelFile;
                                                             wordApp: Variant);
begin
  WriteMatToXLSAndCopyToWord_SinOrdenar(xls, nombreHoja, cronVar.v, titulo, unidades, titulosColsExt, cronVar.nPasos,
                                        cronVar.nCronicas, cronVar.dtIni, cronVar.DurPaso_horas / 24, digitos, decimales,
                                        Print_promedio, chart_Mat,
                                        minEjeYAuto, maxEjeYAuto, minEjeY, MaxEjeY,
                                        wordApp);
end;

*)

class function TPrintCronVar_matrizDeDatos.tipo: String;
begin
  Result := 'matrizDeDatos';
end;

procedure TPrintCronVar_matrizDeDatos.Free;
begin
  SetLength(titulosCols, 0);
  inherited Free;
end;

function TPrintCronVar_matrizDeDatos.parametrosAdicionales: String;
begin
  Result := 'Imprimir Promedio= ' + boolToSiNo(Print_promedio) +
    ', Graficar= ' + boolToSiNo(chart_Mat);
end;

function TPrintCronVar_matrizDeDatos.titulosColsExt: TDAofString;
var
  i: Integer;
  res: TDAofString;
  n: integer;
  s: String;
begin
  if cronVar.nCronicas = Length(titulosCols) then
    res := titulosCols
  else
  begin
    n := length(titulosCols);
    SetLength(res, cronVar.nCronicas);

    if (n > cronVar.nCronicas) then
    begin
      s := 'Error, en TPrintCronVar_matrizDeDatos. '#13#10 +
        'De la cronVar: ' + cronVar.nombre + #13#10 +
        'Especificó más titulos de columnas que la cantidad columnas de la matriz.'#13#10 +
        ' Se ignoran los títulos: '#13#10;
      for i := cronVar.nCronicas to high(titulosCols) do
        s := s + ', ' + titulosCols[i];
      ShowMessage(s);

      n := cronVar.nCronicas;
    end;

    for i := 0 to n - 1 do
      res[i] := titulosCols[i];
    for i := n to high(res) do
      res[i] := 'Cron_' + IntToStr(i + 1);
  end;
  Result := res;
end;

function TPrintCronVar_matrizDeDatos.serialize: string;
begin
  Result := inherited serialize + #9 + encomille(nombreHoja) +
    #9 + encomille(titulo) + #9 + encomille(unidades) +
    #9 + TDAOfStringToStringConTamanio(titulosCols) + #9 +
    IntToStr(digitos) + #9 + IntToStr(decimales) + #9 +
    BoolToStr(Print_promedio, True) + #9 + BoolToStr(chart_Mat, True) +
    #9 + BoolToStr(minEjeYAuto, True) + #9 +
    BoolToStr(maxEjeYAuto, True) + #9 + FloatToStrF(minEjeY,
    ffGeneral, 8, 3) + #9 + FloatToStrF(MaxEjeY, ffGeneral, 8, 3);
end;

//-----------------------------------
//Métodos de TPrintCronVar_histograma
//===================================

Constructor TPrintCronVar_histograma.Create(cronVar: TCronVar;
  nombreHoja: string;
  titulo, unidades: string;
  digitos, decimales: integer;
  Print_Todas: boolean;
  Print_promedio: boolean;
  Pre_Ordenar: boolean;
  TipoImpresion_PE: boolean;
  Print_probAisladas: TDAofNReal;
  chart_Mat: boolean;
  minEjeYAuto, maxEjeYAuto: boolean;
  minEjeY, MaxEjeY: NReal);
begin
  inherited Create;
  self.cronVar := cronVar;
  self.nombreHoja := nombreHoja;
  self.titulo := titulo;
  self.unidades := unidades;
  self.digitos := digitos;
  self.decimales := decimales;
  self.Print_Todas := Print_Todas;
  self.Print_promedio := Print_promedio;
  self.Pre_Ordenar := Pre_Ordenar;
  self.TipoImpresion_PE := TipoImpresion_PE;
  self.Print_probAisladas := Print_probAisladas;
  self.chart_Mat := chart_Mat;
  self.minEjeYAuto := minEjeYAuto;
  self.maxEjeYAuto := maxEjeYAuto;
  self.minEjeY := minEjeY;
  self.MaxEjeY := MaxEjeY;
end;

procedure TPrintCronVar_histograma.imprimirse(xls: TExcelFile);
begin
  WriteMatToXLS(
    xls, nombreHoja, cronVar.v_,
    UTF8TOAnsi(titulo), unidades, cronVar.nPasos,
    cronVar.nCronicas, cronVar.dtIni, cronVar.DurPaso_horas / 24.0,
    decimales,
    Print_Todas, Print_promedio,
    Pre_Ordenar,
    TipoImpresion_PE,
    Print_probAisladas, chart_Mat,
    minEjeYAuto, maxEjeYAuto, minEjeY, MaxEjeY);
end;

(*
procedure TPrintCronVar_Histograma.imprimirseYCopiarAWord(xls: TExcelFile;
                                                          wordApp: Variant);
begin
  WriteMatToXLSAndCopyToWord(xls, nombreHoja, cronVar.v, titulo, unidades, cronVar.nPasos,
                cronVar.nCronicas, cronVar.dtIni, cronVar.DurPaso_horas / 24.0, digitos, decimales,
                Print_Todas, Print_promedio, Print_probAisladas, chart_Mat,
                minEjeYAuto, maxEjeYAuto, minEjeY, MaxEjeY, wordApp);
end;
  *)


class function TPrintCronVar_Histograma.tipo: String;
begin
  Result := 'histograma';
end;

function TPrintCronVar_Histograma.parametrosAdicionales: String;
begin
  if length(Print_probAisladas) > 0 then
    Result := 'Imprimir Promedio= ' + boolToSiNo(Print_promedio) +
      ', Graficar= ' + boolToSiNo(chart_Mat) + ', PrintProbsAisladas= ' +
      TDAOfNRealToStringSinTamanio(Print_probAisladas, 4, 3, ', ')
  else
    Result := 'Imprimir Promedio= ' + boolToSiNo(Print_promedio) +
      ', Graficar= ' + boolToSiNo(chart_Mat) + ', PrintProbsAisladas= no';
end;

class function TPrintCronVar_Histograma.printProbAisladasPorDefecto: TDAofNReal;
var
  printProbsAisladasPorDefecto: TDAofNReal;
begin
  SetLength(printProbsAisladasPorDefecto, 4);
  printProbsAisladasPorDefecto[0] := 0.1;
  printProbsAisladasPorDefecto[1] := 0.3;
  printProbsAisladasPorDefecto[2] := 0.7;
  printProbsAisladasPorDefecto[3] := 0.9;
  Result := printProbsAisladasPorDefecto;
end;

procedure TPrintCronVar_Histograma.Free;
begin
  SetLength(Print_probAisladas, 0);
  inherited Free;
end;


function TPrintCronVar_Histograma.serialize: string;
begin
  Result := inherited serialize + #9 + encomille(nombreHoja) +
    #9 + encomille(titulo) + #9 + encomille(unidades) +
    #9 + IntToStr(digitos) + #9 + IntToStr(decimales) +
    #9 + BoolToStr(Print_Todas, True) + #9 +
    BoolToStr(Print_promedio, True) + #9 + BoolToStr(Pre_Ordenar, True) +
    #9 + BoolToStr(TipoImpresion_PE, True) + #9 +
    TDAOfNRealToTabbedStringConTamanio(Print_probAisladas, 8, 3) +
    #9 + BoolToStr(chart_Mat, True) + #9 + BoolToStr(minEjeYAuto, True) +
    #9 + BoolToStr(maxEjeYAuto, True) + #9 +
    FloatToStrF(minEjeY, ffGeneral, 8, 3) + #9 +
    FloatToStrF(MaxEjeY, ffGeneral, 8, 3);
end;

{$ENDIF}


//-----------------------------------
//Métodos de TPrintCronVar_histograma_text
//===================================

Constructor TPrintCronVar_histograma_text.Create(cronVar: TCronVar;
  archi: string; titulo, unidades: string;
  digitos, decimales: integer; Print_Todas: boolean;
  Print_promedio: boolean; Pre_Ordenar: boolean;
  TipoImpresion_PE: boolean;
  Print_probAisladas: TDAofNReal);
begin
  inherited Create;
  self.cronVar := cronVar;
  if pos('.', archi) = 0 then
    archi := archi + '.xlt';
  self.nombreHoja := archi;
  self.titulo := titulo;
  self.unidades := unidades;
  self.digitos := digitos;
  self.decimales := decimales;
  Self.Print_Todas := Print_Todas;
  Self.Print_promedio := Print_Promedio;
  Self.Pre_Ordenar := Pre_Ordenar;
  Self.TipoImpresion_PE := TipoImpresion_PE;
  Self.Print_probAisladas := Print_probAisladas;
end;


function TPrintCronVar_histograma_text.usa_excel: boolean;
begin
  Result := False;
end;

procedure TPrintCronVar_histograma_text.imprimirse(xls: TExcelFile);
begin
  WriteMatToText(
    nombreHoja,
    cronVar.v_,
    UTF8ToAnsi(titulo), cronVar.nPasos,
    cronVar.nCronicas, cronVar.dtIni, cronVar.DurPaso_horas / 24.0,
    digitos,
    decimales,
    Print_Todas, Print_promedio, Pre_Ordenar, TipoImpresion_PE, Print_probAisladas);
end;

class function TPrintCronVar_histograma_text.tipo: String;
begin
  Result := 'histograma_text';
end;

procedure TPrintCronVar_histograma_text.Free;
begin
  SetLength(Print_probAisladas, 0);
  inherited Free;
end;

function TPrintCronVar_histograma_text.parametrosAdicionales: String;
begin
  if length(Print_probAisladas) > 0 then
    Result := 'Imprimir Promedio= ' + boolToSiNo(Print_promedio) +
      ', PrintProbsAisladas= ' + TDAOfNRealToStringSinTamanio(Print_probAisladas, 4, 3, ', ')
  else
    Result := 'Imprimir Promedio= ' + boolToSiNo(Print_promedio) +
      ', PrintProbsAisladas= no';
end;

class function TPrintCronVar_histograma_text.printProbAisladasPorDefecto: TDAofNReal;
var
  printProbsAisladasPorDefecto: TDAofNReal;
begin
  SetLength(printProbsAisladasPorDefecto, 4);
  printProbsAisladasPorDefecto[0] := 0.1;
  printProbsAisladasPorDefecto[1] := 0.3;
  printProbsAisladasPorDefecto[2] := 0.7;
  printProbsAisladasPorDefecto[3] := 0.9;
  Result := printProbsAisladasPorDefecto;
end;


function TPrintCronVar_Histograma_text.serialize: string;
begin
  Result := inherited serialize + #9 + encomille(nombreHoja) +
    #9 + encomille(titulo) + #9 + encomille(unidades) +
    #9 + IntToStr(digitos) + #9 + IntToStr(decimales) +
    #9 + BoolToStr(Print_Todas, True) + #9 +
    BoolToStr(Print_promedio, True) + #9 + BoolToStr(Pre_Ordenar, True) +
    #9 + BoolToStr(TipoImpresion_PE, True) + #9 +
    TDAOfNRealToTabbedStringConTamanio(Print_probAisladas, 8, 3);
end;

{$IFNDEF SIMRES3SOLOTEXTO}

(** métodos de TPrintCronVar_HistogramaGlobal **)
Constructor TPrintCronVar_HistogramaGlobal.Create(cronVar: TCronVar;
  nombreHoja: string;
  titulo, unidades: string;
  digitos, decimales: integer;
  minX, maxX: NReal;
  nPuntosHistograma: integer{;
                                                  chart_Mat: boolean;
                                                  minEjeYAuto, maxEjeYAuto: boolean;
                                                  minEjeY, MaxEjeY: NReal});
begin
  inherited Create;
  self.cronVar := cronVar;
  self.nombreHoja := nombreHoja;
  self.titulo := titulo;
  self.unidades := unidades;
  self.digitos := digitos;
  self.decimales := decimales;
  self.minX := minX;
  self.maxX := maxX;
  self.nPuntosHistograma := nPuntosHistograma;
{  self.chart_Mat:= chart_Mat;
  self.minEjeYAuto:= minEjeYAuto;
  self.maxEjeYAuto:= maxEjeYAuto;
  self.minEjeY:= minEjeY;
  self.MaxEjeY:= MaxEjeY;}
end;

procedure TPrintCronVar_HistogramaGlobal.imprimirse(xls: TExcelFile);
begin
  writeHistogramaGlobalToXls(xls, nombreHoja, cronVar.v_, UTF8ToAnsi(titulo), unidades,
    decimales, minX, maxX, nPuntosHistograma
                             {, chart_Mat, minEjeYAuto,
                             maxEjeYAuto, minEjeY, MaxEjeY});
end;

procedure TPrintCronVar_HistogramaGlobal.imprimirseYCopiarAWord(xls: TExcelFile;
  wordApp: variant);
begin
  raise Exception.Create(
    'TPrintCronVar_HistogramaGlobal.imprimirseYCopiarAWord: sin implementar');
end;

class function TPrintCronVar_HistogramaGlobal.tipo: String;
begin
  Result := 'HistogramaGlobal';
end;

procedure TPrintCronVar_HistogramaGlobal.Free;
begin
  inherited Free;
end;

function TPrintCronVar_HistogramaGlobal.serialize: String;
begin
  Result := inherited serialize + #9 + encomille(nombreHoja) +
    #9 + encomille(titulo) + #9 + encomille(unidades) +
    #9 + IntToStr(digitos) + #9 + IntToStr(decimales) +
    #9 + FloatToStr(minX) + #9 + FloatToStr(maxX) +
    #9 + IntToStr(nPuntosHistograma);
end;


//---------------------------------------------------------
//Métodos de TPrintCronVar_compararValoresMultiplesCronVars

//=========================================================

Constructor TPrintCronVar_compararValoresMultiplesCronVars.Create(cronVars: TDAOfCronVar;
  nombreHoja: string;
  titulo, unidades: string;
  digitos, decimales: integer;
  tipoValorAComparar:
  TTipoValoresAComparar;
  probExcedencia: NReal;
  Pre_Ordenar: boolean;
  ProbExcedencia_Sup: NReal; // borde superior
  graficar: boolean;
  tiposGraficos:
  TDAOfTTipoGrafico; ejes:
  TDAOfTTipoEje;
  //clDefault hace que elija automático
  colores: TDAOfTColor;
  minEjeYAuto,
  maxEjeYAuto: boolean;
  minEjeY,
  MaxEjeY: NReal);
begin
  inherited Create;
  self.cronVars := cronVars;
  self.nombreHoja := nombreHoja;
  self.titulo := titulo;
  self.unidades := unidades;
  self.digitos := digitos;
  self.decimales := decimales;
  self.tipoValorAComparar := tipoValorAComparar;
  self.probExcedencia := probExcedencia;

  self.Pre_Ordenar := Pre_Ordenar;
  self.ProbExcedencia_Sup := ProbExcedencia_Sup; // borde superior

  self.graficar := graficar;
  self.tiposGraficos := tiposGraficos;
  self.ejes := ejes;
  self.colores := colores;
  self.minEjeYAuto := minEjeYAuto;
  self.maxEjeYAuto := maxEjeYAuto;
  self.minEjeY := minEjeY;
  self.MaxEjeY := MaxEjeY;
end;

procedure TPrintCronVar_compararValoresMultiplesCronVars.checkParams(
  errores: TStringList);
var
  i, nf, nc: Integer;
  i_CronVar_Max_nf, i_CronVar_Max_nc: integer;

begin
  nf := 0;
  nc := 0;
  i_CronVar_Max_nf := 0;
  i_CronVar_Max_nc := 0;

  // primero buscamos los máximos.
  for i := 0 to high(cronVars) do
  begin
    if cronVars[i].nPasos > nf then
    begin
      nf := cronVars[i].nPasos;
      i_CronVar_Max_nf := i;
    end;

    if cronVars[i].nCronicas > nc then
    begin
      nc := cronVars[i].nCronicas;
      i_CronVar_Max_nc := i;
    end;
  end;

  // ahora chequeamos que la dimensión sea 1 o el máximo
  for i := 0 to high(cronVars) do
  begin
    if cronVars[i].v_ = nil then
    begin
      errores.Add('La cronVar "' + cronVars[i].nombre +
        '" no ha sido inicializada.' + ' Asegurese de que "' +
        cronVars[i].nombre + '" sea el resultado de al menos una cronOper o una postOper.');
    end
    else
    begin

 (*
     if ((cronVars[i].nPasos <> 1 ) and ( cronVars[i].nPasos <> nf)) then
         errores.Add('La cronVar "' + cronVars[i].nombre + '" tiene distinta cantidad de pasos que la cronVar "' + cronVars[ i_CronVar_Max_nf].nombre + '".' +
                   ' Para poder imprimir debe seleccionar un conjunto de cronVars con la misma dimensión.');

     if (( cronVars[i].nCronicas <> 1) and ( cronVars[i].nCronicas <> nc)) then
        errores.Add('La cronVar "' + cronVars[i].nombre + '" tiene distinta cantidad de crónicas que la cronVar "' + cronVars[ i_CronVar_Max_nc].nombre + '".' +
                  ' Para poder imprimir debe seleccionar un conjunto de cronVars con la misma dimensión.');

 *)
    end;
  end;
end;

procedure TPrintCronVar_compararValoresMultiplesCronVars.imprimirse(xls: TExcelFile);
var
  nombres: TDAofString;
  mats: array of TMatOfNReal;
  i: Integer;
begin
  SetLength(mats, length(cronVars));
  SetLength(nombres, length(cronVars));

  for i := 0 to high(cronVars) do
  begin
    nombres[i] := Utf8ToAnsi(cronVars[i].nombre);
    mats[i] := cronVars[i].v_;
  end;

  WriteValoresToXLS(
    xls, tipoValorAComparar,
    probExcedencia, Pre_Ordenar,
    ProbExcedencia_Sup,
    nombres, mats, Utf8ToAnsi(nombreHoja), Utf8ToAnsi(titulo), unidades,
    cronVars[0].dtIni, cronVars[0].DurPaso_horas / 24.0,
    decimales,
    graficar, tiposGraficos, ejes, colores,
    minEjeYAuto, maxEjeYAuto, minEjeY, MaxEjeY);

  SetLength(nombres, 0);
  SetLength(mats, 0);
end;

procedure TPrintCronVar_compararValoresMultiplesCronVars.imprimirseYCopiarAWord(
  xls: TExcelFile;
  wordApp: variant);
begin
  raise Exception.Create(
    'TPrintCronVar_compararValoresMultiplesCronVars.imprimirseYCopiarAWord: sin implementar');
end;

class function TPrintCronVar_compararValoresMultiplesCronVars.tipo: String;
begin
  Result := 'CompararValoresMultiplesCronVars';
end;

procedure TPrintCronVar_compararValoresMultiplesCronVars.Free;
begin
  inherited Free;
end;

function TPrintCronVar_compararValoresMultiplesCronVars.parametrosAdicionales: String;
var
  res: String;
begin
  if tipoValorAComparar = ProbabilidadesDeExcedencia then
    res := 'Valores a Comparar= P.E. ' + FloatToStr(probExcedencia) + '[p.u], '
  else
    res := 'Valores a Comparar= ' + TTipoValoresACompararToString(
      tipoValorAComparar) + ', ';

  if graficar then
  begin
    res := res + 'Graficar= si';
  end
  else
    res := res + 'Graficar= no';
  Result := res;
end;

function TPrintCronVar_compararValoresMultiplesCronVars.getColores: TDAOfTColor;
var
  i, nColoresNoDefault: Integer;
  res: TDAOfTColor;
begin
  nColoresNoDefault := 0;
  SetLength(res, length(colores));
  for i := 0 to high(colores) do
    if colores[i] <> colorAutomatico then
    begin
      res[nColoresNoDefault] := colores[i];
      nColoresNoDefault := nColoresNoDefault + 1;
    end;

  if nColoresNoDefault <> Length(res) then
    SetLength(res, nColoresNoDefault);
  Result := res;
end;

function TPrintCronVar_compararValoresMultiplesCronVars.serialize: String;
begin
  Result := inherited serialize + #9 +
    TDAOfCronVarTipoGraficoEjeColorToStringConTamanio(cronVars,
    tiposGraficos,
    ejes,
    colores) +
    #9 + encomille(nombreHoja) + #9 + encomille(titulo) +
    #9 + encomille(unidades) + #9 + IntToStr(digitos) +
    #9 + IntToStr(decimales) + #9 + encomille(
    TTipoValoresACompararToString(tipoValorAComparar)) + #9 +
    FloatToStr(probExcedencia) + #9 + BoolToStr(Pre_Ordenar) +
    #9 + FloatToStr(ProbExcedencia_Sup) + #9 +
    BoolToStr(graficar, True) + #9 + BoolToStr(minEjeYAuto, True) +
    #9 + BoolToStr(maxEjeYAuto, True) + #9 +
    FloatToStrF(minEjeY, ffGeneral, 8, 3) + #9 +
    FloatToStrF(MaxEjeY, ffGeneral, 8, 3);
end;
{$ENDIF}




constructor TPrintCronVar_R.Create(cronVars: TDAOfCronVar;
  carpeta_destino: string; R_Archi: string;
  R_Script: string);
begin
  inherited Create;
  self.carpeta_destino := carpeta_destino;
  self.cronVars := cronVars;
  self.R_archi := R_Archi;
  self.R_Script := R_Script;
end;
function TPrintCronVar_R.usa_excel: boolean;
begin
  result:= false;
end;

procedure TPrintCronVar_R.imprimirse(xls: TExcelFile);
var
  k: integer;
  aCronVar: TCronVar;
  archi: string;
  fs: textfile;
  rparams: array of string;
  sparams: string;
  script_lst, result_lst: TStringList;

begin
  setSeparadoresGlobales; // para que escriba en global

  if not DirectoryExists(carpeta_destino) then
    mkdir(carpeta_destino);
  for k := 0 to high(cronVars) do
  begin
    aCronVar := cronVars[k];
    archi := carpeta_destino + DirectorySeparator + aCronVar.nombre;
    aCronVar.Write_R_csv(archi);
  end;

  (*
  archi := carpeta_destino + DirectorySeparator + Self.R_archi + '.R';
  assignfile(fs, archi);
  rewrite(fs);
  writeln(fs, '# Inicio R script generado por SimSEE');
  writeln(fs, '# Versión SimSEE: ' + vSimSEESimulador_);
  writeln(fs, '# Fecha: ', DateTimeToStr(now()));
  remplazar_letra( carpeta_destino, '\', '/' );
  for k := 0 to high(cronVars) do
  begin
    aCronVar := cronVars[k];
    archi := carpeta_destino + '/' + aCronVar.nombre;
    writeln(fs, aCronVar.nombre + ' <- read.table( "'
    + archi + '.csv",  skip=0, header=TRUE, sep=",", dec="." ) ');
  end;
  writeln(fs, self.R_script);
  writeln(fs, '# Inicio R script generado por SimSEE');
  closefile(fs);
  *)

   script_lst:= TStringList.Create;
   script_lst.add( '# Inicio R script generado por SimSEE');
   script_lst.add( '# Versión SimSEE: ' + vSimSEESimulador_);
   script_lst.add('# Fecha: '+ DateTimeToStr(now()));
   remplazar_letra( carpeta_destino, '\', '/' );
   script_lst.add( 'setwd("'+carpeta_destino+'")');

   for k := 0 to high(cronVars) do
   begin
     aCronVar := cronVars[k];
//     archi := carpeta_destino + '/' + aCronVar.nombre;
     archi := aCronVar.nombre;
     script_lst.add(aCronVar.nombre + ' <- read.table( "'
     + archi + '.csv",  skip=0, header=TRUE, sep=",", dec="." ) ');
   end;
   script_lst.add(self.R_script);
   script_lst.add('q()');
   script_lst.add('# Inicio R script generado por SimSEE');



  archi := carpeta_destino + DirectorySeparator + Self.R_archi + '.R';
  script_lst.SaveToFile( archi );


  setSeparadoresLocales; // para que escriba en global

  archi := carpeta_destino + DirectorySeparator + Self.R_archi + '.R';

  sparams:= '--no-restore --no-save';
  result_lst:= runPipe( 'C:\Program Files\R\R-3.1.2\bin\x64\Rterm.exe', sparams, script_lst );

  setlength( rparams, 1 );
//  rparams[0] := '--no-restore --no-save r001.R > x.out 2>&1';

archi := carpeta_destino + DirectorySeparator + Self.R_archi + '.out';

  result_lst.SaveToFile( archi);
  result_lst.Free;

(*
  setlength( rparams, 5 );
  rparams[0] := 'CMD';
  rparams[1] := 'BATCH';
  rparams[2] := '--no-restore';
  rparams[3] := '--no-save';
  rparams[4] := archi;
  RunChild( 'C:\Program Files\R\R-3.1.2\bin\x64\Rterm.exe', rparams, true );
  setlength( rparams, 0 );
  *)
end;

class function TPrintCronVar_R.tipo: string;
begin
  Result := 'R';
end;

procedure TPrintCronVar_R.Free;
begin
  inherited Free;
end;

function TPrintCronVar_R.parametrosAdicionales: string;
begin
  Result := self.carpeta_destino + ', ' + self.R_archi + ', ' + self.R_script;
end;

function TPrintCronVar_R.serialize: string;
var
  k: integer;
  res: string;
begin
  res:= inherited serialize;
  res:= res + #9+ IntToSTr( length( cronVars ) );
  for k:= 0 to high( CronVars ) do
    res:= res +#9+ cronVars[k].nombre;
  Result := res + #9 + encomille(carpeta_destino) +
    #9 + encomille(R_archi) + #9 + HTTPEncode(R_script);
end;

end.
